/*
 * Status.cpp
 *
 *  Created on: 14 Oct 2020
 *      Author: Jack
 */

#include <Model/Status.hpp>
#include <cstring>


void Status::setDisplacmentEncoderRaw(int value)
{
    displacmentEncoder = value;
}
void Status::zeroDisplacmentEncoder(int zeropt)
{
    displacmentEncoderOffset = displacmentEncoder - zeropt;
}

void Status::setSensorEncoderRaw(int value)
{
    sensorEncoder = value;
}
void Status::zeroSensorEncoder(int zeropt)
{
    sensorEncoderOffset = sensorEncoder - zeropt;
}


void Status::setSensorTorque(int value)
{
    sensorTorque = value;
}

void Status::setMotorSpeed(int value)
{
    motorSpeed = value;
}




int Status::getDisplacmentEncoderCal()
{
    return displacmentEncoder - displacmentEncoderOffset;
}

int Status::getSensorEncoderCal()
{
    return sensorEncoder - sensorEncoderOffset;
}

int Status::getSensorTorque()
{
    return sensorTorque;
}

int Status::getMotorSpeed()
{
    return motorSpeed;
}

const char * Status::getInputString()
{
    return inputString;
}

const char * Status::getOutputString()
{
    outputStringUpdate = false;
    return outputString;
}

void Status::setInputString(const char * string)
{
    inputString[49] = '\0';
    strncpy(inputString, string, 49);
}

void Status::setOutputString(const char * string)
{
    inputString[49] = '\0';
    strncpy(outputString, string, 49);
    outputStringUpdate = true;
}

bool Status::newOutputString()
{
    return outputStringUpdate;
}


void Status::triggerTorqueLimit()
{
    torqueLimitHit = true;
}

void Status::resetTorqueLimit()
{
    torqueLimitHit = false;
}

bool Status::atTorqueTimit()
{
    return torqueLimitHit;
}
