/*
 * Status.hpp
 *
 *  Created on: 14 Oct 2020
 *      Author: Jack
 */

#ifndef MODEL_STATUS_HPP_
#define MODEL_STATUS_HPP_

class Status
{
    int displacmentEncoder = 1;
    int sensorEncoder = 2;
    int displacmentEncoderOffset = 0;
    int sensorEncoderOffset = 0;
    int sensorTorque = 3;
    int motorSpeed = 4;
    char inputString[50] = "";
    char outputString[50] = "";
    bool outputStringUpdate = false;
    bool torqueLimitHit = false;
public:
    void setDisplacmentEncoderRaw(int);
    void zeroDisplacmentEncoder(int zeropt = 0);
    void setSensorEncoderRaw(int);
    void zeroSensorEncoder(int zeropt = 0);
    void setSensorTorque(int);
    void setMotorSpeed(int);
    void setInputString(const char *);
    void setOutputString(const char *);
    void triggerTorqueLimit();
    void resetTorqueLimit();


    int getDisplacmentEncoderCal();
    int getSensorEncoderCal();
    int getSensorTorque();
    int getMotorSpeed();
    const char * getInputString();
    const char * getOutputString();
    bool newOutputString();
    bool atTorqueTimit();
};

#endif /* MODEL_STATUS_HPP_ */
